use std::net::SocketAddr;

use axum::{routing::get, Router};

use crate::app::SharedApp;

pub async fn axum_serve(host: SocketAddr, app: SharedApp) -> anyhow::Result<()> {
    let app = Router::new().route("/", get(root)).with_state(app);

    tracing::info!("listening on {}", host);
    let listener = tokio::net::TcpListener::bind(host).await.unwrap();

    axum::serve(listener, app.into_make_service()).await?;

    Ok(())
}

async fn root() -> &'static str {
    "Hello, flux-releaser!"
}
