pub mod extensions;

#[derive(Clone)]
pub struct DomainEvents {
    nats: Nats,
}

#[cfg(test)]
use mockall::{automock, mock, predicate::*};

use crate::app::infra::{self, nats::Nats};

#[cfg_attr(test, automock)]
impl DomainEvents {
    pub fn new(nats: Nats) -> Self {
        Self { nats }
    }

    pub async fn publish_event(&self, event: &str) -> anyhow::Result<()> {
        tracing::trace!("publish events: {}", event);

        self.nats
            .publish("flux_releaser.domain_events", event)
            .await?;

        Ok(())
    }
}
