use std::{path::PathBuf, sync::Arc};

use super::release_manager::models::ArtifactID;

pub mod extensions;

#[derive(Clone)]
pub struct FileStore {
    client: aws_sdk_s3::Client,
}

#[cfg(test)]
use mockall::{automock, mock, predicate::*};

#[cfg_attr(test, automock)]
impl FileStore {
    pub fn new(client: aws_sdk_s3::Client) -> Self {
        Self { client }
    }

    pub async fn upload_files(
        &self,
        artifact_id: ArtifactID,
        files: Vec<PathBuf>,
    ) -> anyhow::Result<()> {
        tracing::trace!("uploading files: {}", artifact_id.to_string());

        Ok(())
    }
}
